﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SumOfSelectedCell
{
    public partial class Form1 : Form
    {
        int _iRowCount;
        int _iColumnCount;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _iRowCount = fpSpread1.ActiveSheet.RowCount;
            _iColumnCount = fpSpread1.ActiveSheet.ColumnCount;
            fpSpread1.ActiveSheet.SelectionPolicy = FarPoint.Win.Spread.Model.SelectionPolicy.Range;
            for (int i = 0; i < 10; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    fpSpread1.ActiveSheet.Cells[i, j].Text = i + "" + j;
                }
            }
            fpSpread1.SelectionChanging += new FarPoint.Win.Spread.SelectionChangingEventHandler(fpSpread1_SelectionChanging);
          LblSum.Text = "Sum : 0";
          LblAVG.Text = "Average: 0";
          LblCNT.Text = "Count: 0";
        }

       

        void fpSpread1_SelectionChanging(object sender, FarPoint.Win.Spread.SelectionChangingEventArgs e)
        {
            //Calculate the Sum of the Selection
            Double sum = 0;
            int count = 0;
            int avgCount = 0;
            //When selection perform using row header
            if (e.Range.Column == -1)
            {
                for (int i = e.Range.Row; i < e.Range.Row + e.Range.RowCount; i++)
                {
                    for (int j = 0; j <= fpSpread1.ActiveSheet.GetLastNonEmptyColumn(FarPoint.Win.Spread.NonEmptyItemFlag.Data); j++)
                        try
                        {
                            if (fpSpread1.ActiveSheet.Cells[i, j].Text != string.Empty)
                            {
                                sum = sum + Double.Parse(fpSpread1.ActiveSheet.Cells[i, j].Text);
                                avgCount++;
                                count++;

                            }
                        }
                        catch
                        {
                            if (fpSpread1.ActiveSheet.Cells[i, j].Text != string.Empty)
                            count++;
                        }
                }
            }
                // Selection perform using Column Header
            else if (e.Range.Row == -1)
            {
                for (int i = 0; i <= fpSpread1.ActiveSheet.GetLastNonEmptyRow(FarPoint.Win.Spread.NonEmptyItemFlag.Data); i++)
                {
                    for (int j = e.Range.Column; j < e.Range.Column + e.Range.ColumnCount; j++)
                        try
                        {
                            if (fpSpread1.ActiveSheet.Cells[i, j].Text != string.Empty)
                            {
                                sum = sum + Double.Parse(fpSpread1.ActiveSheet.Cells[i, j].Text);
                                avgCount++;
                                count++;
                            }
                        }
                        catch
                        {
                            if (fpSpread1.ActiveSheet.Cells[i, j].Text != string.Empty)
                            count++;
                        }
                }
            }
               
            else
            {
                for (int i = e.Range.Row; i < e.Range.Row + e.Range.RowCount; i++)
                {
                    for (int j = e.Range.Column; j < e.Range.Column + e.Range.ColumnCount; j++)
                        try
                        {
                            if (fpSpread1.ActiveSheet.Cells[i, j].Text != string.Empty)
                            {
                                sum = sum + Double.Parse(fpSpread1.ActiveSheet.Cells[i, j].Text);
                                avgCount++;
                                count++;

                            }
                        }
                        catch
                        {
                            if (fpSpread1.ActiveSheet.Cells[i, j].Text != string.Empty)
                            count++;
                        }
                }
            }
            //Display Sum, Avg and Count
            LblSum.Text = "Sum: " + sum;
            if (avgCount > 0)
                LblAVG.Text = "Average: " + (sum / (Double)avgCount);
            else
                LblAVG.Text = "Average: 0";
            LblCNT.Text = "Count: " + count;
            
        }

        private void fpSpread1_CellClick(object sender, FarPoint.Win.Spread.CellClickEventArgs e)
        {
            Double sum = 0;
            int count = 0;
            int avgCount = 0;
           
                if (e.RowHeader == true)
                {
                    //Calculate the Sum of the Selection corresponding row
                    for (int i = 0; i <= fpSpread1.ActiveSheet.GetLastNonEmptyColumn(FarPoint.Win.Spread.NonEmptyItemFlag.Data); i++)
                    {
                        try
                        {
                            if (fpSpread1.ActiveSheet.Cells[e.Row, i].Text != string.Empty)
                            {
                                sum = sum + Double.Parse(fpSpread1.ActiveSheet.Cells[e.Row, i].Text);
                                avgCount++;
                                count++;
                            }
                        }

                        catch
                        {
                            if (fpSpread1.ActiveSheet.Cells[e.Row, i].Text != string.Empty)
                            count++;
                        }
                    }
                }
                else if (e.ColumnHeader == true)
                {
                    //Calculate the Sum of the Selection corresponding column
                    for (int i = 0; i <= fpSpread1.ActiveSheet.GetLastNonEmptyRow(FarPoint.Win.Spread.NonEmptyItemFlag.Data); i++)
                    {
                        try
                        {
                            if (fpSpread1.ActiveSheet.Cells[i, e.Column].Text != string.Empty)
                            {
                                sum = sum + Double.Parse(fpSpread1.ActiveSheet.Cells[i, e.Column].Text);
                                avgCount++;
                                count++;
                            }
                        }

                        catch
                        {
                            if(fpSpread1.ActiveSheet.Cells[i, e.Column].Text != string.Empty)
                            count++;
                        }
                    }
                }
           

            //Display Sum, Avg and Count
            LblSum.Text = "Sum: " + sum;
            if (avgCount > 0)
                LblAVG.Text = "Average: " + (sum / (Double)avgCount);
            else
                LblAVG.Text = "Average: 0";
            LblCNT.Text = "Count: " + count;
        }
    }
}
